"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Panel = Panel;

var _react = require("react");

var _queryString = _interopRequireDefault(require("query-string"));

var _api = require("@storybook/api");

var _theming = require("@storybook/theming");

var _constants = require("./constants");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["options"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ABSTRACT_APP_URL = process.env.STORYBOOK_ABSTRACT_APP_URL || "https://app.abstract.com";

var Iframe = _theming.styled.iframe({
  width: "100%",
  height: "100%",
  border: "0 none"
});

function parseShareURL(url) {
  if (url.match(/share.(?:go)?abstract.com\//)) {
    var parsedUrl = new URL(url);
    var pathSegments = parsedUrl.pathname.split("/");
    return pathSegments[pathSegments.length - 1];
  }

  throw new Error("The provided url (".concat(url, ") is not valid. The url must come from \"https://share.abstract.com/\" or \"https://share.goabstract.com/\"."));
}

function Panel() {
  var _useStorybookState = (0, _api.useStorybookState)(),
      storyId = _useStorybookState.storyId;

  var params = (0, _api.useParameter)(_constants.PARAM_KEY);
  return (0, _react.useMemo)(function () {
    // Ignore stories without abstract parameters
    if (!params) return null;

    var _params$options = params.options,
        options = _params$options === void 0 ? {} : _params$options,
        shareDescriptor = _objectWithoutProperties(params, _excluded);

    var shareId;

    if ("url" in shareDescriptor) {
      shareId = parseShareURL(shareDescriptor.url);
    } else if ("shareId" in shareDescriptor) {
      shareId = shareDescriptor.shareId;
    }

    if (!shareId) {
      throw new Error("Could not infer share id from ShareDescriptor: \"".concat(JSON.stringify(shareDescriptor), "\""));
    }

    var url = new URL("/embed/".concat(shareId), ABSTRACT_APP_URL);
    url.search = _queryString["default"].stringify(_objectSpread(_objectSpread({}, options), {}, {
      find: (params === null || params === void 0 ? void 0 : params.find) || storyId
    }));
    return /*#__PURE__*/(0, _jsxRuntime.jsx)(Iframe, {
      src: url.toString()
    });
  }, [params, storyId]);
}